/**************************************************************************
* DSemu: Interrupt triggering and flag clear (int.c)                      *
* Released under the terms of the BSD Public Licence                      *
* Imran Nazar (tf@oopsilon.com), 2004                                     *
**************************************************************************/

#include "defs.h"
#include "int.h"
#include "arm9.h"
#include "dsioreg.h"

u16 intFired=0;
extern u16 intr9Bitmask;
extern u16 intrBitmask;

void IntFire(u16 interrupt)
{
    if(REG(ARM9_REG,IME))
    {
		if((intr9Bitmask&interrupt) && (REG(ARM9_REG,IE)&interrupt))
		{
			REG(ARM9_REG,IF)|=interrupt;
			ARM9InterruptFlagChanged();
			intFired=interrupt;
			ARM9irq();
		}
    }
    if(REG(ARM7_REG,IME))
    {
		if((intrBitmask&interrupt) && (REG(ARM7_REG,IE)&interrupt))
		{
			REG(ARM7_REG,IF)|=interrupt;
			ARM7InterruptFlagChanged();
			intFired=interrupt;
			ARM7irq();
		}
    }
}

void IntClear(u16 interrupt)
{
    REG(ARM9_REG,IF)&=(0xFFFF-interrupt);
	ARM9InterruptFlagChanged();
    REG(ARM7_REG,IF)&=(0xFFFF-interrupt);
	ARM7InterruptFlagChanged();
}

/*** EOF:int.c ***********************************************************/

